/* -*- Mode: C++; c-file-style: "stroustrup"; indent-tabs-mode: nil -*- */
/*
 * main.cc
 *   Sample program for the exception class.
 *
 * $Id: main.cc,v 1.4 2000/12/27 16:59:27 rex Exp $
 *
 * Copyright (C) 2000 Remi Lefebvre <remi@debian.org>
 * Copyright (c) 2000 Benoit Joly <benoit@dhis.net>
 *
 * Licensed under the GPLv2
 */

#include <iostream>
#include "Exception.h"

int main()
{
     try 
     {
          throw DdtException("Something fucked up.");
     }
     catch (DbError &e) 
     {
          cout << "Caught Database Error: " << e.message() << endl;
     }
     catch (DdtException &e) 
     {
          cout << "Caught Generic DDT Exception: " << e.message() << endl;
     }
     catch (...) 
     {
          cout << "Unknown exception" << endl;
     }

     try 
     {
          // dont throw anything
     }
     catch (DbError &e) 
     {
          cout << "Caught Database Error: " << e.message() << endl;
     }
     catch (DdtException &e) 
     {
          cout << "Caught Generic DDT Exception: " << e.message() << endl;
     }
     catch (...) 
     {
          cout << "Unknown exception" << endl;
     }

     try 
     {
          throw DbError();
     }
     catch (DbError &e) 
     {
          cout << "Caught Database Error: " << e.message() << endl;
     }
     catch (DdtException &e) 
     {
          cout << "Caught Generic DDT Exception: " << e.message() << endl;
     }
     catch (...) 
     {
          cout << "Unknown exception" << endl;
     }
    
     return 0;
}
